package com.bcxin.saas.core.components;

import com.bcxin.saas.core.components.dtos.DataPermissionType;
import com.bcxin.saas.core.enums.EnvironmentType;
import lombok.Getter;
import org.apache.commons.lang3.StringUtils;

@Getter
public class DataPermissionScopeConfig {
    public static final String ALL_PERMISSIONS = "*";
    private final String dataScoped;

    private final EnvironmentType environmentType;

    public DataPermissionScopeConfig(String dataScoped,
                                     EnvironmentType environmentType) {
        this.dataScoped = dataScoped;
        this.environmentType = environmentType;
    }

    public boolean isAllowedAllData() {
        return environmentType == EnvironmentType.Government_Inner && !StringUtils.isEmpty(dataScoped) && "all".equalsIgnoreCase(dataScoped);
    }


    public static String getPermissionCacheKey(DataPermissionType permissionType, String id) {
        return String.format("com:scopes:pms:%s:%s", permissionType, id);
    }

    public static String getPermissionScopeCacheKey(DataPermissionType permissionType, String id) {
        return String.format("com:scopes:pms:%s:scope:%s", permissionType, id);
    }
}
