package com.bcxin.saas.core.utils;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.HashMap;
import java.util.Map;

public class ThreadRequestUtil {
    private static final Logger logger = LoggerFactory.getLogger(ThreadRequestUtil.class);
    private static ThreadLocal<Map<String, Object>> _threadRequestContainer = new InheritableThreadLocal<Map<String, Object>>() {
        @Override
        protected Map<String, Object> initialValue() {
            return new HashMap<>();
        }
    };

    private static Map<String, Object> getThreadRequestContainer() {
        Map<String, Object> container = _threadRequestContainer.get();
        return container;
    }


    private static void storeThreadRequestContainer(Map<String, Object> container) {
        _threadRequestContainer.set(container);
    }

    public static void setIsFeatureEnabled(String featureKey, boolean enable) {
        Map<String, Object> container = getThreadRequestContainer();

        container.put(featureKey, enable);

        storeThreadRequestContainer(container);
    }

    public static boolean getIsFeatureEnabled(String featureKey) {
        try {
            Map<String, Object> container = getThreadRequestContainer();
            return (boolean) container.get(featureKey);
        } catch (Exception ex) {
            logger.error("获取是否企业打印功能无效:{}", featureKey, ex);
            
            return false;
        }
    }
}
